## xournalpp 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 ## Also update changelog in debian folder!
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "1")
-set (CPACK_PACKAGE_VERSION_PATCH "1")
+set (CPACK_PACKAGE_VERSION_PATCH "2")
 set (CPACK_DEBIAN_PACKAGE_RELEASE 1)
 set (VERSION_SUFFIX "")
 set (PROJECT_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}${VERSION_SUFFIX}")
@@ -90,7 +90,6 @@
 	find_package(ImageMagick REQUIRED COMPONENTS convert)
 else ()
 	find_package(Backtrace REQUIRED)
-	add_includes_ldflags("${Backtrace_LIBRARIES}" "${Backtrace_INCLUDE_DIRS}")
 endif ()
 
 # GLIB
