## xournalpp 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 ## Also update changelog in debian folder!
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "1")
-set (CPACK_PACKAGE_VERSION_PATCH "2")
+set (CPACK_PACKAGE_VERSION_PATCH "3")
 set (CPACK_DEBIAN_PACKAGE_RELEASE 1)
 set (VERSION_SUFFIX "")
 set (PROJECT_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}${VERSION_SUFFIX}")
