=== src/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,20 @@
 file (GLOB xournalpp_SOURCES_RECURSE
   pdf/popplerapi/*.cpp
 )
+
+###############################
+# Add MacOS specific files
+# Todo(Roland): consider moving this into an own MacOS specific cmake script
+# e.g. exe/macos/CMakeLists.txt
+##############################
+
+if (APPLE)
+  # MacOS specific source files
+  # Concatenate SOURCES lists
+  set (xournalpp_SOURCES ${xournalpp_SOURCES_RECURSE} ${xournalpp_SOURCES})
+  unset (xournalpp_SOURCES_RECURSE)
+  file (GLOB xournalpp_SOURCES_RECURSE osx/*.cpp osx/*.h)
+endif()
 
 if (WIN32)
   # generate .ico from .png
