=== src/util/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,10 @@
 
 add_library (util STATIC ${util_SOURCES})
 add_dependencies(util std::filesystem)
-target_link_libraries(util PUBLIC std::filesystem cxx17)
+target_link_libraries(util PUBLIC std::filesystem cxx17 ${Backtrace_LIBRARY})
 target_compile_features(util PUBLIC ${PROJECT_CXX_FEATURES})
 target_include_directories(util PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+        ${Backtrace_INCLUDE_DIR}
         #$<INSTALL_INTERFACE:>  # <prefix>/include/mylib
         )
