=== debian/changelog ===
xournalpp (1.1.3-1) unstable; urgency=medium

  * new upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 01 Dec 2022 20:45:23 +0000
