=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: xournalpp
 Maintainer: Barak A. Pearlmutter <bap@debian.org>
+Uploaders: Mike Gabriel <sunweaver@debian.org>
 Section: x11
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends: debhelper-compat (= 13), cmake,
 	libcppunit-dev,
 	help2man,
