=== debian/changelog ===
xournalpp (1.2.0-1) unstable; urgency=medium

  * New upstream version
  * Upstream commit 9172ee83 fixes GCC-13 FTBFS (closes: #1037904)
  * Update standards version to 4.6.2, no changes needed.
  * Patch minor spelling error
  * Remove upstreamed quilt patches, which is all of 'em

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 31 Jul 2023 00:42:03 +0100
