=== debian/control ===
Source: xournalpp
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Section: x11
Priority: optional
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), cmake,
	libcppunit-dev,
	help2man,
	libgtk-3-dev, libpoppler-glib-dev, libxml2-dev,
	portaudio19-dev, libsndfile1-dev | libsndfile-dev, liblua5.3-dev, libzip-dev, librsvg2-dev, libgtksourceview-4-dev
Rules-Requires-Root: no
Homepage: https://github.com/xournalpp/xournalpp/
Vcs-Git: https://salsa.debian.org/debian/xournalpp.git
Vcs-Browser: https://salsa.debian.org/debian/xournalpp

Package: xournalpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: texlive-base, texlive-latex-extra
Recommends: lua-lgi
Description: Xournal++ - Open source hand note-taking program
 Xournal++ is a hand note-taking software written in C++ with the target of
 flexibility, functionality and speed. Stroke recognizer and other parts are
 based on Xournal Code, which you can find at sourceforge.
 It supports Linux (e.g. Ubuntu, Debian, Arch, SUSE), macOS and Windows 10.
 Supports pen input from devices such as Wacom Tablets.
 .
 Xournal++ features:
 .
  - Supports pressure-sensitive styluses and digital pen tables (e.g. Wacom, Huion, XP Pen, etc. tablets)
  - Paper backgrounds for note-taking, scratch paper, or whiteboarding
  - Annotate on top of PDFs
  - Export to a variety of formats including SVG, PNG and PDF, both from the GUI and command line
  - Different drawing tools (e.g. pen, highlighter) and stroke styles (e.g. solid, dotted)
  - Shape drawing (line, arrow, circle, rectangle, spline)
  - Fill shape functionality
  - Shape resizing and rotation
  - Rotation and grid snapping for precise alignment of objects
  - Input stabilization for smoother writing/drawing
  - Text tool for adding text in different fonts, colors, and sizes
  - Enhanced support for image insertion
  - Eraser with multiple configurations
  - LaTeX support (requires a working LaTeX installation) with customizable template
  - Sidebar containing page previews with advanced page sorting, PDF bookmarks and layers (can be individually hidden/edited)
  - Allows maping different tools/colors etc. to stylus/mouse buttons
  - Customizable toolbar with multiple configurations, e.g. to optimize toolbar for portrait/landscape
  - Page template definitions
  - Bug reporting, autosave, and auto backup tools
  - Audio recording and playback alongside with handwritten notes
  - Multi language support (over 20 languages supported)
  - Plugins using Lua scripting
